#if !defined(__fncy_dap_h)              // Sentry, use file only if it's not already included.
#define __fncy_dap_h

/*  Project fancy_ed
    Terry Richards Software
    Copyright  1994. All Rights Reserved.

    SUBSYSTEM:    fancy_ed.exe Application
    FILE:         fncy_dap.h
    AUTHOR:       Terry Richards


    OVERVIEW
    ========
    Class definition for fancy_edApp (TApplication).      
*/


#include <owl\owlpch.h>
#pragma hdrstop

#include <classlib\bags.h>

#include "fnc_mdic.h"

#include "fncy_dap.rh"            // Definition of all resources.


// TFileDrop class Maintains information about a dropped file, its name, where it was dropped,
// and whether or not it was in the client area
class TFileDrop {
public:
    operator == (const TFileDrop& other) const {return this == &other;}

    char*   FileName;
    TPoint  Point;
    bool    InClientArea;

    TFileDrop (char*, TPoint&, bool, TModule*);
    ~TFileDrop ();

    const char* WhoAmI ();
private:
    //
    // hidden to prevent accidental copying or assignment
    //
    TFileDrop (const TFileDrop&);
    TFileDrop & operator = (const TFileDrop&);
};

typedef TIBagAsVector<TFileDrop> TFileList;
typedef TIBagAsVectorIterator<TFileDrop> TFileListIter;


//{{TApplication = fancy_edApp}}
class fancy_edApp : public TApplication {
private:

    void SetupSpeedBar (TDecoratedMDIFrame *frame);
    void AddFiles (TFileList* files);

public:
    fancy_edApp ();
    virtual ~fancy_edApp ();

    TOpenSaveDialog::TData  FileData;                   // Data to control open/saveas standard dialog.

    fancy_edMDIClient  *mdiClient;

    // Public data members used by the print menu commands and Paint routine in MDIChild.
    TPrinter *      Printer;                           // Printer support.
    int             Printing;                           // Printing in progress.
    TStatusBar *    sb;

//{{fancy_edAppVIRTUAL_BEGIN}}
public:
    virtual void InitMainWindow();
    virtual void InitInstance();
//{{fancy_edAppVIRTUAL_END}}

//{{fancy_edAppRSP_TBL_BEGIN}}
protected:
    void CmHelpAbout ();
    void EvDropFiles (TDropInfo drop);
    void EvWinIniChange (char far* section);
//{{fancy_edAppRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(fancy_edApp);
};    //{{fancy_edApp}}


#endif                                      // __fncy_dap_h sentry.
